﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Comparer
{
	public partial class NamesForm : Form
	{
		private String _sname;
		private String _dname;
		private SettingsClass _sc;

		public NamesForm(String sname, String dname, SettingsClass sc)
		{
			InitializeComponent();
			this._sname = sname;
			this._dname = dname;
			this._sc = sc;
		}

		private void button1_Click( object sender, EventArgs e )
		{
			this.Close();
		}

		private void NamesForm_Load( object sender, EventArgs e )
		{
			String firstfile = "d:\\picture.jpg";
			String secondfile = "c:\\test\\text.txt";
			String output = "";

			//single

			output = this._sname;

			label1.Text = firstfile;
			label2.Text = CheckVariables(firstfile, this._sname);

			if (CheckInvalidChars( label2.Text ))
			{
				err1Label.Visible = true;
				sfmGB.Height = 82;
			}
			else
			{
				err1Label.Visible = false;
				sfmGB.Height = 62;
				dfmGB.Top = sfmGB.Top + sfmGB.Height + 6;
			}
			
			//double

			label3.Text = firstfile;
			label4.Text = secondfile;
			label5.Text = CheckVariables( firstfile, secondfile, this._dname );

			if (CheckInvalidChars( label5.Text ))
			{
				err2Label.Visible = true;				
				dfmGB.Height = 102;				
			}
			else
			{
				err2Label.Visible = false;				
				dfmGB.Height = 82;				
			}

			this.Height = dfmGB.Top + dfmGB.Height + 30 + closeBtn.Height + 20;	
		
			//language
			this.Text = this._sc.GetLangText( "ShowDlgTitle" );

			sfmGB.Text = this._sc.GetLangText( "ShowDlgSFile" );

			fileLabel.Text = this._sc.GetLangText( "ShowDlgFile" );
			output1Label.Text = this._sc.GetLangText( "ShowDlgFirstOut" );
			err1Label.Text = this._sc.GetLangText( "ShowDlgError" );

			dfmGB.Text = this._sc.GetLangText( "ShowDlgDFile" );
			file1Label.Text = this._sc.GetLangText( "ShowDlgFirst" );
			file2Label.Text = this._sc.GetLangText( "ShowDlgSecond" );
			output2Label.Text = this._sc.GetLangText( "ShowDlgDoubleOut" );
			err2Label.Text = this._sc.GetLangText( "ShowDlgError" );

			closeBtn.Text = this._sc.GetLangText( "ShowDlgCloseBtn" );
		}

		public static String CheckVariables(String filename, String vars)
		{
			String tmp = vars;
						
			if (vars.Contains( "%fs" ))
			{
				tmp = tmp.Replace( "%fs", ShortFile( filename ) );
			}

			if (vars.Contains( "%ff" ))
			{
				tmp = tmp.Replace( "%ff", FullFile( filename ) );				
			}

			if (vars.Contains( "%df" ))
			{
				tmp = FormattedDate(tmp );
			}

			return tmp;
		}

		public static String CheckVariables( String firstfile, String secondfile, String vars )
		{
			String tmp = vars;

			if (vars.Contains( "%f1s" ))
			{
				tmp = tmp.Replace( "%f1s", ShortFile( firstfile ) );
			}

			if (vars.Contains( "%f2s" ))
			{
				tmp = tmp.Replace( "%f2s", ShortFile( secondfile ) );
			}

			if (vars.Contains( "%f1f" ))
			{
				tmp = tmp.Replace( "%f1f", FullFile( firstfile ) );
			}

			if (vars.Contains( "%f2f" ))
			{
				tmp = tmp.Replace( "%f2f", FullFile( secondfile ) );
			}

			if (vars.Contains( "%df" ))
			{
				tmp = FormattedDate( tmp );
			}

			return tmp;
		}

		public static String ShortFile(String filename)
		{
			String tmp = filename;
			tmp = tmp.Substring(tmp.LastIndexOf('\\') + 1);
			tmp = tmp.Substring( 0, tmp.LastIndexOf( '.' ) );

			return tmp;
		}

		public static String FullFile( String filename )
		{
			String tmp = filename;
			tmp = tmp.Substring( tmp.LastIndexOf( '\\' ) + 1 );
			tmp = tmp.Replace( '.', '_' );			

			return tmp;
		}
		/*
		public static String FullPath( String filename )
		{
			String tmp = filename;
			tmp = tmp.Substring(0, tmp.LastIndexOf( '\\' ) );			

			return tmp;
		}
		*/
		public static String FormattedDate(String vars )
		{
			String tmp = vars.Substring( vars.IndexOf( "%df" ) + 3 , vars.Length - vars.IndexOf( "%df" ) - 3);
			String tmpfor = "";
			String tmpdat = "";

			if (!tmp.Equals( "" ) && tmp[0].Equals( '(' ))
			{
				if (tmp.Contains( ")" ))
				{
					tmpfor = tmp.Substring( 1, tmp.IndexOf( ')' ) - 1 );
					
					try
					{
						tmpdat = DateTime.Now.Date.ToString( tmpfor );
					}
					catch (Exception exc)
					{
						tmpdat = "<ERRDATE>";
					}

					tmp = vars.Replace( "%df(" + tmpfor + ")", tmpdat );
				}
			}
			else
			{
				tmp = vars;
			}

			return tmp;
		}

		private Boolean CheckInvalidChars(String tmp)
		{
			if (tmp.Contains( "<" ) || tmp.Contains( ">" ) || tmp.Contains( ":" ) || tmp.Contains( "/" )
				|| tmp.Contains( "\\" ) || tmp.Contains( "|" ) || tmp.Contains( "?" ) || tmp.Contains( "*" ))
			{
				return true;
			}
			/*
			if (tmp.ToUpper().Equals( "CON" ) || tmp.ToUpper().Equals( "PRN" ) || tmp.ToUpper().Equals( "AUX" ))
			{
				return true;
			}

			for (int i = 1; i < 10; i++)
			{
				if (tmp.ToUpper().Equals( "COM" + i.ToString()) )
				{
					return true;
				}

				if (tmp.ToUpper().Equals( "LPT" + i.ToString() ))
				{
					return true;
				}
			}*/

			if (tmp.Equals( "" ))
			{
				return true;
			}

			return false;
		}

		public static String ReplaceInvalidChars( String tmp )
		{
			if (tmp.Contains( "<" ) || tmp.Contains( ">" ) || tmp.Contains( ":" ) || tmp.Contains( "/" )
				|| tmp.Contains( "\\" ) || tmp.Contains( "|" ) || tmp.Contains( "?" ) || tmp.Contains( "*" ))
			{
				tmp = tmp.Replace( "<", "_" );
				tmp = tmp.Replace( ">", "_" );
				tmp = tmp.Replace( ":", "_" );
				tmp = tmp.Replace( "/", "_" );
				tmp = tmp.Replace( "\\", "_" );
				tmp = tmp.Replace( "|", "_" );
				tmp = tmp.Replace( "?", "_" );
				tmp = tmp.Replace( "*", "_" );
			}
			/*
			if (tmp.ToUpper().Equals( "CON" ) || tmp.ToUpper().Equals( "PRN" ) || tmp.ToUpper().Equals( "AUX" ))
			{
				tmp = tmp.Replace( "CON", "XXX" );
				tmp = tmp.Replace( "PRN", "XXX" );
				tmp = tmp.Replace( "AUX", "XXX" );
			}

			for (int i = 1; i < 10; i++)
			{
				if (tmp.ToUpper().Equals( "COM" + i.ToString() ))
				{
					tmp = tmp.Replace( "COM", "XXX" );
				}

				if (tmp.ToUpper().Equals( "LPT" + i.ToString() ))
				{
					tmp = tmp.Replace( "LPT", "XXX" );
				}
			}*/

			if (tmp.Equals( "" ))
			{
				tmp = "output";
			}

			return tmp;
		}

	}
}
